/* vi:set ts=8 sts=0 sw=8:
 * $Id: main.h,v 1.34 1999/12/13 08:55:23 kahn Exp kahn $
 *
 * Copyright (C) 1998 Andy C. Kahn
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __MAIN_H__
#define __MAIN_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <stdio.h>
#include <stdarg.h>
#include <assert.h>
#include "../config.h"
#include <gtk/gtk.h>
#ifdef WANT_GNOME
#include <config.h>
#include <gnome.h>
#endif
#ifdef USE_GTKHTML
#include <gtkhtml/gtkhtml.h>
#endif
#ifdef USE_GTKXMHTML
#include <gtk-xmhtml/gtk-xmhtml.h>
#endif
#include "debug.h"


#ifdef APP_GNP
# define APP_NAME	"gnotepad+"
# define APP_VERSION	VERSION
# define APP_DATE	"December-13-1999"
# define APP_URL	"http://ack.netpedia.net/gnp"
#endif

#define UNTITLED	"Untitled"
#define UNKNOWN		"Unknown"
#define WELCOME_MSG	"Welcome to "
#define NULL_CALLBACK	NULL
#define COL_VAL_GDK	65535.0		/* GdkColor is 16-bit color */
#define COL_VAL_HTML	255.0		/* HTML specifies 8-bit color in hex */
#define MAX_RGB_STR	32

#ifdef MAXPATH
# undef MAXPATH
#endif
#define MAXPATH		255

#ifndef ESUCCESS		/* hmm, this is missing on my Linux box */
# define ESUCCESS        0
#endif

#ifdef USE_REGEX
# undef USE_REGEX
#endif
#if defined(HAVE_REGCOMP) && defined(HAVE_REGERROR) && \
    defined(HAVE_REGEXEC) && defined(HAVE_REGFREE) && defined(HAVE_REGEX_H)
# define USE_REGEX
#endif

typedef unsigned char bool_t;
typedef char byte;
typedef unsigned char ubyte;

typedef enum { FnumCol = 0, FsizeCol, FnameCol } clist_col_t;

#ifndef GTK_HAVE_FEATURES_1_1_0
extern char *g_vsprintf(const char *fmt, va_list *args, va_list *args2);
#define gtk_container_set_border_width(w, v)	gtk_container_border_width(w, v)
#define gtk_editable_set_position(e, p)		(e)->current_pos = (p)
#define gtk_editable_get_position(e)		(e)->current_pos
#define gtk_notebook_get_current_page(nb)	gtk_notebook_current_page(nb)
#define gtk_editable_copy_clipboard(e)		\
		gtk_editable_copy_clipboard((e), GDK_CURRENT_TIME)
#define gtk_editable_cut_clipboard(e)		\
		gtk_editable_cut_clipboard((e), GDK_CURRENT_TIME)
#define gtk_editable_paste_clipboard(e)		\
		gtk_editable_paste_clipboard((e), GDK_CURRENT_TIME)
#define gtk_window_set_position(gw, pos)	gtk_window_position((gw), (pos))
#define gtk_toggle_button_set_active(t, f)	(t)->active = (f)
#endif


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	/* __MAIN_H__ */
