/*
 * The Rubick's cube.
 * Had some hours to kill.
 *
 * Sed - april 1999.
 *
 * This is of course total free sofware, or public domain or what you want.
 * Kill copyrights. Kill copylefts.
 *--------------------
 * The wait event function, or how to show the superiority of select in face of threads shit.
 */

#include "event.h"

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include <X11/Xlib.h>

#include "sound.h"
#include "screen.h"
#include "cube.h"

int can_mix(int fd)
{
  fd_set w;
  struct timeval t;

  FD_ZERO(&w);

  t.tv_sec=0;
  t.tv_usec=0;

  FD_SET(fd, &w);

  select(fd+1, 0, &w, 0, &t);

  return FD_ISSET(fd, &w);
}

/* return -1 of error, and what it has to, read it */
int wait_event(SCREEN *s, SOUND *sound, CUBE *c)
{
  fd_set r, w;
  struct timeval t;//, u;
  int ret;
  XEvent ev;

  FD_ZERO(&r);
  FD_ZERO(&w);

  t.tv_sec=0;
  t.tv_usec=0; //50*1000;

#if 0
  u.tv_sec=0;
  u.tv_usec=200*1000;
#endif

  FD_SET(ConnectionNumber(s->d), &r);

  if (sound->on)
    FD_SET(sound->fd, &w);

  if (c->rotate)
    while((ret=select(FD_SETSIZE, &r, &w, 0, &t))==-1) {
      if (errno!=EINTR) {
	perror("select");
	return -1;
      }
    }
#if 0
  else if (sound->on && sound->move)
    while((ret=select(FD_SETSIZE, &r, &w, 0, &u))==-1) {
      if (errno!=EINTR) {
	perror("select");
	return -1;
      }
    }
#endif
  else
    while((ret=select(FD_SETSIZE, &r, &w, 0, (struct timeval *)0))==-1) {
      if (errno!=EINTR) {
	perror("select");
	return -1;
      }
    }

  if (!ret) {
    return CUBE_EVENT;
  }
  ret=0;

  if (FD_ISSET(sound->fd, &w))
    ret|=SOUND_EVENT;

  if (FD_ISSET(ConnectionNumber(s->d), &r))
    ret|=SCREEN_EVENT;
  else { /* I have to do this XCheckMaskEvent because X functions might already have taken
	  * away from the socket some events, that I may see too late, producing
	  * bad results for the player.
	  */
    if (XCheckMaskEvent(s->d, -1L, &ev)!=False) {
      ret |= SCREEN_EVENT;
      XPutBackEvent(s->d, &ev);
    }
  }

  return ret;
}
