;
; This file is part of xsoundtrack - a sound tracker for Linux.
; Sed - april 1999.
; This is total free software.
;-------------------------------------
; The file contains a mixer (assembler version), ie routines necessary to write the sound to the soundcard.
;

;genral note : how to deal with C.
;first arg after push ebp mov ebp,esp : [ebp+8], second [ebp+12], etc...
;esp-xxx : to have local vars
;or enter xx, 0 where xx is the nb of _bytes_ to locally alloc
;[ebp-4] : first local var, [ebp-8] : second, so on...

bits 32
section .text

;extern functions
extern play_sound
extern new_line
extern live_new_line

;extern data
extern mixer_buffer_soundcard
extern mixer_soft_buffer

%define MIX_SIZE	2048	;in bytes
%define	OUT_SIZE	1024	;in bytes

;so, here we are. I have to mix 256 data (ie an output buffer of 256*2*2=1024 (stereo, 16b) bytes)
;and a mixer buffer of 2048 bytes because of 32b mixing.
;algo (basic, no live player, no dump to wav):
;mix :
;if 0 bytes to handle then new_line
;while (!handled all samples)
;  handle x bytes where x is a min of mix buf size and to handle of the line (so x is byte unit)
;  if over return
;  new_line
;endwhile
;
;handle x bytes :
;for each channel
;  handle_channel_x_bytes
;
;handle_channel_x_bytes (one version for 16b one for 8b) :
;  get one datum of the sample
;  calculate left and right value
;  put it in buffer
;  point to next datum (take care of forward/ping pong loop, not for now, so if end of sample, close channel)
;until all x bytes done
;
;

;data from xm.h
;int
%define to_handle 	2396
;short
%define nb_channels	52
;channel
%define channels	2412
;int
%define do_we_dump	11500
;int
%define dumped		11504
;int
%define live_to_handle	2404
;channel
%define live_channels	11508
;int
%define xm_mix		2368

;data from channels_def.h
%define CHANNEL_SIZE	284
;unsigned long long
%define sample_position	8
;unsigned long long
%define increment	16
;int
%define increment_positif 24
;int
%define in_use		28
;int
%define do_we_delay	40
;sample *
%define sample		4
;char *
%define sample_data	12
;int
%define left_volume	32
;int
%define right_volume	36
;int
%define sample_length	0
;int
%define sample_loop_start 4
;int
%define sample_loop_length 8
;char
%define sample_type 16

global mix:function
%define	xm		[ebp+8]
%define to_do		[ebp-4]
%define turn_do		[ebp-8]
%define chan_nb		[ebp-12]
%define nb_channels_copy	[ebp-16]
mix:	enter	16, 0
	push	esi
	push	edi
	push	ebx
	mov	dword to_do, 1024*2 ;byte unit
	mov	edi, mixer_soft_buffer
	;clear soft buffer
	mov	ecx, 256*2
	xor	eax, eax
	cld
	rep stosd
	sub	edi, 256*2*4
	;if 0 bytes to handle, let's call new_line
	mov	esi, xm
	test	byte [esi+xm_mix], 1		;MODULE_PLAY, it must be 1 !!
	jz	near .fin
	mov	ax, [esi+nb_channels]
	mov	nb_channels_copy, ax
	mov	eax, [esi+to_handle]
	or	eax, eax
	jnz	.1
.0:	push	dword xm
	call	new_line
	add	esp, 4
	mov	[esi+to_handle], eax
	;if still 0, dump mode
	or	eax, eax
	jnz	.1
	mov	eax, to_do
	neg	eax
	add	eax, 1024*2
	shr	eax, 2
	mov	[esi+dumped], eax
	mov	byte [esi+do_we_dump], 0
	pop	ebx
	pop	edi
	pop	esi
	leave
	ret
.1:	;let's see how many bytes to handle
	mov	ebx, to_do
	cmp	ebx, eax
	jbe	.2
	mov	ebx, eax
.2:	;mov	turn_do, ebx
	sub	[esi+to_handle], ebx	;we can sub now, why wait, huh ?
	sub	to_do, ebx
	;handle one turn
	xor	eax, eax
	mov	chan_nb, eax
	push	esi
	add	esi, channels
.3:	call	handle_one_channel
	add	esi, CHANNEL_SIZE
	inc	dword chan_nb
	mov	eax, chan_nb
	cmp	ax, nb_channels_copy
	jnz	.3
	add	edi, ebx
	pop	esi
	;turn over, let's continue with less bytes
	cmp	dword to_do, 0
	jnz	.0

.fin:	;test if do_we_dump
	cmp	byte [esi+do_we_dump], 0
	jz	.no_dump
	;ok we dump
	mov	dword [esi+dumped], 512
	pop	ebx
	pop	edi
	pop	esi
	leave
	ret
.no_dump:;now, the live player. Damned.
	test	byte [esi+xm_mix], 2
	jz	.no_live
	mov	dword to_do, 1024*2 ;byte unit
	mov	edi, mixer_soft_buffer
	call	live_play
.no_live:
	;ok, soft buffer is done, now translate to output buffer
	mov	esi, mixer_soft_buffer
	mov	edi, mixer_buffer_soundcard
	mov	ecx, 256*2
	cld
.fin.1:	lodsd
	sar	eax, 3
	stosw
	dec	ecx
	jne	.fin.1
	;and now, play it
	push	dword 1024
	push	dword mixer_buffer_soundcard
	call	play_sound
	add	esp, 8
	pop	ebx
	pop	edi
	pop	esi
	leave
	ret

live_play:
	mov	ax, 10
	mov	nb_channels_copy, ax
	mov	eax, [esi+live_to_handle]
	or	eax, eax
	jnz	.1
.0:	push	dword xm
	call	live_new_line
	add	esp, 4
	mov	[esi+live_to_handle], eax
	;if still 0, bug ! in fact it's impossible, so no test.
%if 0
	or	eax, eax
	jnz	.1
	mov	eax, to_do
	neg	eax
	add	eax, 1024*2
	shr	eax, 2
	mov	[esi+dumped], eax
	mov	byte [esi+do_we_dump], 0
	pop	ebx
	pop	edi
	pop	esi
	leave
	ret
%endif
.1:	;let's see how many bytes to handle
	mov	ebx, to_do
	cmp	ebx, eax
	jbe	.2
	mov	ebx, eax
.2:	;mov	turn_do, ebx
	sub	[esi+live_to_handle], ebx	;we can sub now, why wait, huh ?
	sub	to_do, ebx
	;handle one turn
	xor	eax, eax
	mov	chan_nb, eax
	push	esi
	add	esi, live_channels
.3:	call	handle_one_channel
	add	esi, CHANNEL_SIZE
	inc	dword chan_nb
	mov	eax, chan_nb
	cmp	ax, nb_channels_copy
	jnz	.3
	add	edi, ebx
	pop	esi
	;turn over, let's continue with less bytes
	cmp	dword to_do, 0
	jnz	.0
	ret

;handle_channel_x_bytes (one version for 16b one for 8b) :
;  get one datum of the sample
;  calculate left and right value
;  put it in buffer
;  point to next datum (take care of forward/ping pong loop, not for now, so if end of sample, close channel)
;until all x bytes done

handle_one_channel: ;this function writes turn_do bytes into the mix buffer from the current channel
;esi points to the channel structure
;ebx gives the nb of bytes to write
;esi can't be changed, all other registers become what you want.
;edi and ebx must be restored to their initial value (so a push/pop)
	cmp	byte [esi+in_use], 0
	jnz	.0
	ret
.0:	cmp	byte [esi+do_we_delay], 0
	jz	.00
	ret
.00:	push	edi
	push	ebx
	push	ebp
	;put some values into local space to economize registers
	mov	ecx, [esi+left_volume]
	mov	edx, [esi+right_volume]
	mov	[l_vol], ecx
	mov	[r_vol], edx
	mov	ecx, [esi+increment]
	mov	edx, [esi+increment+4]
	mov	[inc_chan], ecx
	mov	[inc_chan+4], edx
	mov	ebp, [esi+sample]
	mov	ecx, [ebp+sample_loop_start]
	mov	edx, [ebp+sample_loop_length]
	mov	[loop_start], ecx
	add	edx, ecx
	mov	[loop_end], edx
	mov	ecx, [ebp+sample_length]
	mov	[samp_len], ecx
	or	ecx, ecx
	jz	.fin
	;ok, let's go
	xor	eax, eax
	mov	al, [ebp+sample_type]
	shr	al, 2
	or	al, [ebp+sample_type]
	and	al, 7
	mov	ecx, [esi+sample_position]
	mov	edx, [esi+sample_position+4]
	mov	ebp, [ebp+sample_data]
	or	ebp, ebp
	jz	.fin
	jmp	[eax*4+mixer_32b_functions]
.fin:	mov	byte [esi+in_use], 0
	pop	ebp
	pop	ebx
	pop	edi
	ret	

handle_one_channel_8b_no_loop:
.1:	cmp	edx, [samp_len]
	jae	.fin1
	movsx	eax, byte [edx+ebp]
	imul	eax, [l_vol]
	shl	eax, 2
	add	[edi], eax
	movsx	eax, byte [edx+ebp]
	imul	eax, [r_vol]
	shl	eax, 2
	add	[edi+4], eax
	add	ecx, [inc_chan]
	adc	edx, [inc_chan+4]
	add	edi, 8
	sub	ebx, 8
	jg	.1
	mov	[esi+sample_position], ecx
	mov	[esi+sample_position+4], edx
	pop	ebp
	pop	ebx
	pop	edi
	ret	
.fin1:	mov	byte [esi+in_use], 0
	pop	ebp
	pop	ebx
	pop	edi
	ret	

handle_one_channel_8b_forward_loop:
.1:	cmp	edx, [loop_end]
	jb	.2
	mov	edx, [loop_start]
	xor	ecx, ecx
.2:	movsx	eax, byte [edx+ebp]
	imul	eax, [l_vol]
	shl	eax, 2
	add	[edi], eax
	movsx	eax, byte [edx+ebp]
	imul	eax, [r_vol]
	shl	eax, 2
	add	[edi+4], eax
	add	ecx, [inc_chan]
	adc	edx, [inc_chan+4]
	add	edi, 8
	sub	ebx, 8
	jg	.1
	mov	[esi+sample_position], ecx
	mov	[esi+sample_position+4], edx
	pop	ebp
	pop	ebx
	pop	edi
	ret	
.fin1:	mov	byte [esi+in_use], 0
	pop	ebp
	pop	ebx
	pop	edi
	ret	

handle_one_channel_8b_ping_pong_loop:
	mov	eax, [esi+increment_positif]
	jmp	[eax*4+_8b_ping_pong]
_8b_forward:
.1:	cmp	edx, [loop_end]
	jb	.2
	mov	edx, [loop_end]
	xor	ecx, ecx
	mov	byte [esi+increment_positif], 0
	jmp	_8b_backward.2
.2:	movsx	eax, byte [edx+ebp]
	imul	eax, [l_vol]
	shl	eax, 2
	add	[edi], eax
	movsx	eax, byte [edx+ebp]
	imul	eax, [r_vol]
	shl	eax, 2
	add	[edi+4], eax
	add	ecx, [inc_chan]
	adc	edx, [inc_chan+4]
	add	edi, 8
	sub	ebx, 8
	jg	.1
	mov	[esi+sample_position], ecx
	mov	[esi+sample_position+4], edx
	pop	ebp
	pop	ebx
	pop	edi
	ret	
_8b_backward:
.1:	cmp	edx, [loop_start]
	jg	.2
	mov	edx, [loop_start]
	xor	ecx, ecx
	mov	byte [esi+increment_positif], 1
	jmp	_8b_forward.2
.2:	movsx	eax, byte [edx+ebp]
	imul	eax, [l_vol]
	shl	eax, 2
	add	[edi], eax
	movsx	eax, byte [edx+ebp]
	imul	eax, [r_vol]
	shl	eax, 2
	add	[edi+4], eax
	sub	ecx, [inc_chan]
	sbb	edx, [inc_chan+4]
	add	edi, 8
	sub	ebx, 8
	jg	.1
	mov	[esi+sample_position], ecx
	mov	[esi+sample_position+4], edx
	pop	ebp
	pop	ebx
	pop	edi
	ret	

handle_one_channel_16b_no_loop:
.1:	cmp	edx, [samp_len]
	jae	.fin1
	push	edx
	and	edx, 0xfffffffe
	movsx	eax, word [edx+ebp]
	imul	eax, [l_vol]
	sar	eax, 6
	add	[edi], eax
	movsx	eax, word [edx+ebp]
	imul	eax, [r_vol]
	sar	eax, 6
	add	[edi+4], eax
	pop	edx
	add	ecx, [inc_chan]
	adc	edx, [inc_chan+4]
	add	edi, 8
	sub	ebx, 8
	jg	.1
	mov	[esi+sample_position], ecx
	mov	[esi+sample_position+4], edx
	pop	ebp
	pop	ebx
	pop	edi
	ret	
.fin1:	mov	byte [esi+in_use], 0
	pop	ebp
	pop	ebx
	pop	edi
	ret	

handle_one_channel_16b_forward_loop:
.1:	cmp	edx, [loop_end]
	jb	.2
	mov	edx, [loop_start]
	xor	ecx, ecx
.2:	push	edx
	and	edx, 0xfffffffe
	movsx	eax, word [edx+ebp]
	imul	eax, [l_vol]
	sar	eax, 6
	add	[edi], eax
	movsx	eax, word [edx+ebp]
	imul	eax, [r_vol]
	sar	eax, 6
	add	[edi+4], eax
	pop	edx
	add	ecx, [inc_chan]
	adc	edx, [inc_chan+4]
	add	edi, 8
	sub	ebx, 8
	jg	.1
	mov	[esi+sample_position], ecx
	mov	[esi+sample_position+4], edx
	pop	ebp
	pop	ebx
	pop	edi
	ret	
.fin1:	mov	byte [esi+in_use], 0
	pop	ebp
	pop	ebx
	pop	edi
	ret	

handle_one_channel_16b_ping_pong_loop:
	mov	eax, [esi+increment_positif]
	jmp	[eax*4+_16b_ping_pong]
_16b_forward:
.1:	cmp	edx, [loop_end]
	jb	.2
	mov	edx, [loop_end]
	xor	ecx, ecx
	mov	byte [esi+increment_positif], 0
	jmp	_16b_backward.2
.2:	push	edx
	and	edx, 0xfffffffe
	movsx	eax, word [edx+ebp]
	imul	eax, [l_vol]
	sar	eax, 6
	add	[edi], eax
	movsx	eax, word [edx+ebp]
	imul	eax, [r_vol]
	sar	eax, 6
	add	[edi+4], eax
	pop	edx
	add	ecx, [inc_chan]
	adc	edx, [inc_chan+4]
	add	edi, 8
	sub	ebx, 8
	jg	.1
	mov	[esi+sample_position], ecx
	mov	[esi+sample_position+4], edx
	pop	ebp
	pop	ebx
	pop	edi
	ret	
_16b_backward:
.1:	cmp	edx, [loop_start]
	jg	.2
	mov	edx, [loop_start]
	xor	ecx, ecx
	mov	byte [esi+increment_positif], 1
	jmp	_16b_forward.2
.2:	push	edx
	and	edx, 0xfffffffe
	movsx	eax, word [edx+ebp]
	imul	eax, [l_vol]
	sar	eax, 6
	add	[edi], eax
	movsx	eax, word [edx+ebp]
	imul	eax, [r_vol]
	sar	eax, 6
	add	[edi+4], eax
	pop	edx
	sub	ecx, [inc_chan]
	sbb	edx, [inc_chan+4]
	add	edi, 8
	sub	ebx, 8
	jg	.1
	mov	[esi+sample_position], ecx
	mov	[esi+sample_position+4], edx
	pop	ebp
	pop	ebx
	pop	edi
	ret	

section .bss
inc_chan resd 2
l_vol resd 1
r_vol resd 1
samp_len resd 1
loop_start resd 1
loop_end resd 1

section .data

;XYZ :
;X=8/16b
;Y=1 => ping pong loop
;Z=1 => forward loop
mixer_32b_functions	dd handle_one_channel_8b_no_loop	;000
			dd handle_one_channel_8b_forward_loop	;001
			dd handle_one_channel_8b_ping_pong_loop	;010
			dd handle_one_channel_8b_no_loop	;011 ;impossible
			dd handle_one_channel_16b_no_loop	;100
			dd handle_one_channel_16b_forward_loop	;101
			dd handle_one_channel_16b_ping_pong_loop;110
			dd handle_one_channel_16b_no_loop	;111 ;impossible

_8b_ping_pong	dd _8b_backward
		dd _8b_forward

_16b_ping_pong	dd _16b_backward
		dd _16b_forward
